// naumann@stce.rwth-aachen.de

#include<iostream>

class live_countable {
  static size_t c;
public:
  live_countable() { c++; }
  ~live_countable() { c--; }
  static const size_t& get_live_count() { return c; }
};

size_t live_countable::c=0;

struct printable : public live_countable {
  virtual void print() const=0;
};

template<typename F, typename S>
class pair : public printable {
  F f; S s;
public:
  pair(const F& f, const S& s) : f(f), s(s) {}
  void print() const {
    std::cout << f << " " << s << std::endl;
  }
};

int main() {
  pair<int,bool> p(42,true);
  {
    pair<int,bool> p(24,false);
    p.print(); 
    std::cout << pair<int,bool>::get_live_count() << std::endl;
  }
  p.print(); 
  std::cout << pair<int,bool>::get_live_count() << std::endl;
  return 0;
}

